Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoTabBoxDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoTabBoxDragger.h>`

Inheritance diagram for SoTabBoxDragger:

List of all members.

## Detailed Description

The SoTabBoxDragger wraps a box around geometry you can then translate and scale.

Here's how the dragger looks with it's default geometry in the inactive state:

This dragger lets the end-user do translation and non-uniform scaling of geometry with an easy to understand interface.

Click and drag any side of the box to translate (hold down a SHIFT key to lock to one axis) and click and drag any of the tab markers in the corners to scale. The way the different tabs influences the scale operation should be straight-forward and intuitive to the end-user.

The SoTabBoxDragger is a composite dragger, implemented with 6 SoTabPlaneDragger instances set up as the sides of a box.

## Public Member Functions
| SoTabBoxDragger (void)
void | adjustScaleTabSize (void)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFVec3f | translation
SoSFVec3f | scaleFactor
## Protected Member Functions
| ~SoTabBoxDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
## Static Protected Member Functions
void | invalidateSurroundScaleCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)
## Protected Attributes
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor

## Constructor & Destructor Documentation

SoTabBoxDragger::SoTabBoxDragger | ( | void |  | ) |

| Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry. Node kit structure (new entries versus parent class marked with arrow prefix):
      CLASS SoTabBoxDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "surroundScale"
      -->      "tabPlane1Sep"
      -->         "tabPlane1Xf"
      -->         "tabPlane1"
      -->      "tabPlane2Sep"
      -->         "tabPlane2Xf"
      -->         "tabPlane2"
      -->      "tabPlane3Sep"
      -->         "tabPlane3Xf"
      -->         "tabPlane3"
      -->      "tabPlane4Sep"
      -->         "tabPlane4Xf"
      -->         "tabPlane4"
      -->      "tabPlane5Sep"
      -->         "tabPlane5Xf"
      -->         "tabPlane5"
      -->      "tabPlane6Sep"
      -->         "tabPlane6Xf"
      -->         "tabPlane6"
               "geomSeparator"
      -->         "boxGeom"
(See SoBaseKit::printDiagram() for information about the output formatting.) Detailed information on catalog parts:
      CLASS SoTabBoxDragger
      PVT   "this",  SoTabBoxDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
            "surroundScale",  SoSurroundScale  ---
      PVT   "tabPlane1Sep",  SoSeparator  ---
      PVT   "tabPlane1Xf",  SoTransform  ---
            "tabPlane1",  SoTabPlaneDragger  ---
      PVT   "tabPlane2Sep",  SoSeparator  ---
      PVT   "tabPlane2Xf",  SoTransform  ---
            "tabPlane2",  SoTabPlaneDragger  ---
      PVT   "tabPlane3Sep",  SoSeparator  ---
      PVT   "tabPlane3Xf",  SoTransform  ---
            "tabPlane3",  SoTabPlaneDragger  ---
      PVT   "tabPlane4Sep",  SoSeparator  ---
      PVT   "tabPlane4Xf",  SoTransform  ---
            "tabPlane4",  SoTabPlaneDragger  ---
      PVT   "tabPlane5Sep",  SoSeparator  ---
      PVT   "tabPlane5Xf",  SoTransform  ---
            "tabPlane5",  SoTabPlaneDragger  ---
      PVT   "tabPlane6Sep",  SoSeparator  ---
      PVT   "tabPlane6Xf",  SoTransform  ---
            "tabPlane6",  SoTabPlaneDragger  ---
      PVT   "geomSeparator",  SoSeparator  ---
            "boxGeom",  SoSeparator  ---
(See SoBaseKit::printTable() for information about the output formatting.)

SoTabBoxDragger::~SoTabBoxDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoTabBoxDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

void SoTabBoxDragger::adjustScaleTabSize | ( | void |  | ) |

| Signals the dragger to recalculate the size of its tabs. Simply calls SoTabPlaneDragger::adjustScaleTabSize() for all 6 planes this dragger consists of.

SbBool SoTabBoxDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoTabBoxDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

| (Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.) This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations. This is typically done when: field value is `NULL` and part is `NULL` by default it is a leaf SoGroup or SoSeparator node with no children it is a leaf listpart with no children and an SoGroup or SoSeparator container it is a non-leaf part and it's of SoGroup type and all fields are at their default values Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method. Reimplemented from SoDragger.

void SoTabBoxDragger::invalidateSurroundScaleCB | ( | void * | d,
|  | SoDragger * | d
| ) | `[static, protected]`

| surroundScale is invalidated every time a child dragger is activated/deactivated using this callback

void SoTabBoxDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoTabBoxDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

SoSFVec3f SoTabBoxDragger::translation

| Continuously updated to contain the current translation from the dragger's local origo position.

SoSFVec3f SoTabBoxDragger::scaleFactor

| Continuously updated to contain the current vector of scaling along the X, Y and Z axes.

SoFieldSensor * SoTabBoxDragger::translFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTabBoxDragger::scaleFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTabBoxDragger.h
- SoTabBoxDragger.cpp